## kdenlive 22.08.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

# An odd patch version number means development version, while an even one means
# stable release. An additional number can be used for bugfix-only releases.

# KDE Application Version, managed by release script
set (RELEASE_SERVICE_VERSION_MAJOR "22")
set (RELEASE_SERVICE_VERSION_MINOR "08")
set (RELEASE_SERVICE_VERSION_MICRO "3")

set(KDENLIVE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")

project(Kdenlive VERSION ${KDENLIVE_VERSION})

if(POLICY CMP0063)
  cmake_policy(SET CMP0063 NEW)
endif()
if(POLICY CMP0053)
    cmake_policy(SET CMP0053 NEW)
endif()

# To be switched on when releasing.
option(RELEASE_BUILD "Remove Git revision from program version" ON)
option(BUILD_TESTING "Build tests" ON)
option(CRASH_AUTO_TEST "Auto-generate testcases upon some crashes (uses RTTR library, needed for fuzzing)" OFF)
option(BUILD_FUZZING "Build fuzzing target" OFF)
option(NODBUS "Build without DBus IPC" OFF)
option(USE_VERSIONLESS_TARGETS "Use versionless targets" OFF)

# Minimum versions of main dependencies.
set(MLT_MIN_MAJOR_VERSION 7)
set(MLT_MIN_MINOR_VERSION 8)
set(MLT_MIN_PATCH_VERSION 0)
set(MLT_MIN_VERSION ${MLT_MIN_MAJOR_VERSION}.${MLT_MIN_MINOR_VERSION}.${MLT_MIN_PATCH_VERSION})

# KDE Frameworks
set(KF_DEP_VERSION "5.86.0")
find_package(ECM ${KF_DEP_VERSION} REQUIRED CONFIG)
set(KDE_COMPILERSETTINGS_LEVEL 5.80)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} ${CMAKE_SOURCE_DIR}/cmake/modules)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(FeatureSummary)
include(ECMInstallIcons)
include(GenerateExportHeader)
include(KDEInstallDirs)
include(KDECMakeSettings)
include(ECMOptionalAddSubdirectory)
include(ECMMarkNonGuiExecutable)
include(ECMAddAppIcon)
include(ECMQtDeclareLoggingCategory)
include(ECMEnableSanitizers)
include(ECMAddQch)
if (ECM_VERSION VERSION_GREATER_EQUAL "5.89.0")
    include(QtVersionOption)
endif()
if (ECM_VERSION VERSION_GREATER_EQUAL "5.91.0")
    include(ECMDeprecationSettings)
endif()

add_definitions(-DTRANSLATION_DOMAIN=\"kdenlive\")
find_package(KF5 ${KF_DEP_VERSION} REQUIRED COMPONENTS Archive Bookmarks CoreAddons Config ConfigWidgets
                            KIO WidgetsAddons NotifyConfig NewStuff XmlGui Notifications GuiAddons TextWidgets IconThemes Declarative Solid
                 OPTIONAL_COMPONENTS DocTools FileMetaData Crash Purpose)

# Qt
set(QT_MIN_VERSION 5.15.2)
if (NOT DEFINED QT_MAJOR_VERSION)
    set(QT_MAJOR_VERSION 5)
endif()

if (ECM_VERSION VERSION_GREATER_EQUAL "5.91.0")
    ecm_set_disabled_deprecation_versions(
        QT ${QT_MIN_VERSION}
        KF ${KF_DEP_VERSION}
    )
endif()


find_package(Qt${QT_MAJOR_VERSION} REQUIRED COMPONENTS Core Widgets Svg Quick QuickControls2 Concurrent QuickWidgets Multimedia NetworkAuth)
if (QT_MAJOR_VERSION STREQUAL "6")
    find_package(Qt${QT_MAJOR_VERSION} ${QT_MIN_VERSION} REQUIRED NO_MODULE COMPONENTS SvgWidgets)
endif()
if(NOT NODBUS)
    find_package(KF5 ${KF_DEP_VERSION} REQUIRED COMPONENTS DBusAddons)
    find_package(Qt${QT_MAJOR_VERSION} REQUIRED COMPONENTS DBus)
endif()
add_definitions(-DQT_NO_CAST_TO_ASCII -DQT_NO_URL_CAST_FROM_STRING)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${Qt${QT_MAJOR_VERSION}Widgets_EXECUTABLE_COMPILE_FLAGS}")

# MLT
find_package(MLT ${MLT_MIN_VERSION} REQUIRED)
set_package_properties(MLT PROPERTIES DESCRIPTION "Multimedia framework"
                URL "https://mltframework.org"
                PURPOSE "Required to do video processing")
message(STATUS "Found MLT++: ${MLTPP_LIBRARIES}")

# Windows
include(CheckIncludeFiles)
check_include_files(malloc.h HAVE_MALLOC_H)
check_include_files(pthread.h HAVE_PTHREAD_H)
if(WIN32)
    find_package(DrMinGW)
    set(MLT_PREFIX "..")
else()
    set(MLT_PREFIX ${MLT_ROOT_DIR})
endif()

# macOS
if(APPLE)
    set(DATA_INSTALL_PREFIX "")
else()
    set(DATA_INSTALL_PREFIX "/kdenlive")
endif()

if(KF5FileMetaData_FOUND)
  message(STATUS "Found KF5 FileMetadata to extract file metadata")
  set(KF5_FILEMETADATA TRUE)
else()
  message(STATUS "KF5 FileMetadata not found, file metadata will not be available")
endif()

if(KF5Purpose_FOUND)
  message(STATUS "Found KF5 Purpose, filesharing enabled")
  set(KF5_PURPOSE TRUE)
else()
  message(STATUS "KF5 Purpose not found, filesharing disabled")
endif()

if(KF5DocTools_FOUND)
    add_subdirectory(doc)
    kdoctools_install(po)
endif()

# Get current version.
set(KDENLIVE_VERSION_STRING "${KDENLIVE_VERSION}")
if(NOT RELEASE_BUILD AND EXISTS ${CMAKE_SOURCE_DIR}/.git)
  # Probably a Git workspace; determine the revision.
  find_package(Git QUIET)
  if(GIT_FOUND)
    exec_program(${GIT_EXECUTABLE} ${CMAKE_SOURCE_DIR}
	  ARGS "log -n 1 --pretty=format:\"%h\""
      OUTPUT_VARIABLE KDENLIVE_GIT_REVISION)
    message(STATUS "Kdenlive Git revision: ${KDENLIVE_GIT_REVISION}")
    set(KDENLIVE_VERSION_STRING "${KDENLIVE_VERSION} (rev. ${KDENLIVE_GIT_REVISION})")
  else()
    message(STATUS "Kdenlive Git revision could not be determined")
  endif()
endif()

if(CRASH_AUTO_TEST)
  find_package(RTTR 0.9.6 QUIET)
  if(NOT RTTR_FOUND)
    message(STATUS "RTTR not found on system, will download source and build it")
    include(rttr.CMakeLists.txt)
  endif()
  if(BUILD_FUZZING)
    set(ECM_ENABLE_SANITIZERS fuzzer;address)
  endif()
endif()

feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)

option(BUILD_QCH "Build source code documentation in QCH format (for e.g. Qt Assistant, Qt Creator & KDevelop)" OFF)
add_feature_info(QCH ${BUILD_QCH} "Source code documentation in QCH format (for e.g. Qt Assistant, Qt Creator & KDevelop)")

set(FFMPEG_SUFFIX "" CACHE STRING "FFmpeg custom suffix")
configure_file(config-kdenlive.h.cmake config-kdenlive.h @ONLY)
set(CMAKE_POSITION_INDEPENDENT_CODE TRUE)

# Sources
add_subdirectory(src)
add_subdirectory(renderer)
add_subdirectory(thumbnailer)
add_subdirectory(data)
ki18n_install(po)

if (BUILD_QCH)
    ecm_install_qch_export(
        TARGETS Kdenlive_QCH
        FILE KdenliveQCHTargets.cmake
        DESTINATION "${CMAKE_INSTALL_PREFIX}/lib/cmake/kdenlive"
        COMPONENT Devel
    )
endif()

include(GNUInstallDirs)
install(FILES AUTHORS README.md DESTINATION ${CMAKE_INSTALL_DOCDIR})
install(DIRECTORY LICENSES DESTINATION ${CMAKE_INSTALL_DOCDIR})

install(FILES kdenlive.categories DESTINATION ${KDE_INSTALL_LOGGINGCATEGORIESDIR})

# Tests
if(BUILD_TESTING)
    add_subdirectory(tests)
endif()
if(BUILD_FUZZING AND ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang"))
    add_subdirectory(fuzzer)
elseif(BUILD_FUZZING)
    message(STATUS "Fuzzing build was requested but not enabled because compiler is ${CMAKE_CXX_COMPILER_ID} and not Clang")
endif()

# pre-commit hook
include(KDEGitCommitHooks)
kde_configure_git_pre_commit_hook(CHECKS CLANG_FORMAT)

=== data/CMakeLists.txt ===
add_subdirectory(effects)
add_subdirectory(generators)
add_subdirectory(transitions)
add_subdirectory(icons)
add_subdirectory(knewstuff)
add_subdirectory(lumas)
add_subdirectory(scripts)
add_subdirectory(man)
add_subdirectory(titles)
add_subdirectory(profiles)
add_subdirectory(resourceproviders)
add_subdirectory(shortcuts)
add_subdirectory(luts)

if (APPLE)
# Apple app package
set_target_properties(kdenlive PROPERTIES MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_SOURCE_DIR}/Info.plist)
set_target_properties(kdenlive PROPERTIES
    MACOSX_BUNDLE_DISPLAY_NAME "Kdenlive"
    MACOSX_BUNDLE_BUNDLE_NAME "Kdenlive"
    MACOSX_BUNDLE_LONG_VERSION_STRING "Kdenlive ${RELEASE_SERVICE_VERSION}"
    MACOSX_BUNDLE_SHORT_VERSION_STRING "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}"
    MACOSX_BUNDLE_BUNDLE_VERSION "${RELEASE_SERVICE_VERSION}"
    MACOSX_BUNDLE_GUI_IDENTIFIER "org.kde.Kdenlive"
    MACOSX_BUNDLE_COPYRIGHT "2000-2022 The Kdenlive Authors")

endif()

install(FILES
  meta_magiclantern.png
  encodingprofiles.rc
  externalproxies.rc
  kdenliveeffectscategory.rc
  kdenlivetranscodingrc
  kdenlivedefaultlayouts.rc
  slideanimations.rc

  DESTINATION ${KDE_INSTALL_DATADIR}${DATA_INSTALL_PREFIX})

if (ECM_VERSION VERSION_GREATER_EQUAL "5.89.0")
    install(FILES  kdenlive.notifyrc DESTINATION ${KDE_INSTALL_KNOTIFYRCDIR})
else()
    install(FILES  kdenlive.notifyrc DESTINATION ${KDE_INSTALL_KNOTIFY5RCDIR})
endif()
install(FILES profiles.xml DESTINATION ${KDE_INSTALL_DATADIR}${DATA_INSTALL_PREFIX}/export)
install(FILES org.kde.kdenlive.appdata.xml DESTINATION ${KDE_INSTALL_METAINFODIR})
install(FILES org.kde.kdenlive.desktop DESTINATION ${KDE_INSTALL_APPDIR})

find_package(SharedMimeInfo REQUIRED)
install(FILES org.kde.kdenlive.xml westley.xml DESTINATION ${KDE_INSTALL_MIMEDIR})
update_xdg_mimetypes(${KDE_INSTALL_MIMEDIR})

=== src/CMakeLists.txt ===
### Find packages files
find_package(LibV4L2)
set_package_properties(LibV4L2 PROPERTIES
    DESCRIPTION "video4linux support libraries"
    URL "https://linuxtv.org/downloads/v4l-utils/"
    TYPE RUNTIME
    PURPOSE "Required for better webcam support")

if(WIN32)
    set(MLT_MELTBIN "melt.exe")
    set(MLT_DATADIR "../share/mlt")
elseif(APPLE)
    set(MLT_MELTBIN "melt")
    set(MLT_DATADIR "../Resources/mlt")
else()
    find_package(PkgConfig QUIET)
    execute_process(
        COMMAND ${PKG_CONFIG_EXECUTABLE} --variable=mltdatadir mlt-framework-7
        OUTPUT_VARIABLE MLT_DATADIR
        RESULT_VARIABLE MLT_DATADIR_failed)
    if(NOT MLT_DATADIR_failed)
        string(REGEX REPLACE "[\r\n]" "" MLT_DATADIR "${MLT_DATADIR}")
    endif()

    execute_process(
        COMMAND ${PKG_CONFIG_EXECUTABLE} --variable=meltbin mlt-framework-7
        OUTPUT_VARIABLE MLT_MELTBIN
        RESULT_VARIABLE MLT_MELTBIN_failed)
    if(NOT MLT_MELTBIN_failed)
        string(REGEX REPLACE "[\r\n]" "" MLT_MELTBIN "${MLT_MELTBIN}")
    endif()
endif()
configure_file(mlt_config.h.in ${CMAKE_BINARY_DIR}/mlt_config.h)

check_include_files(linux/input.h HAVE_LINUX_INPUT_H)
if(HAVE_LINUX_INPUT_H)
    list(APPEND kdenlive_SRCS
        jogshuttle/jogmanager.cpp
        jogshuttle/jogaction.cpp
        jogshuttle/jogshuttle.cpp
        jogshuttle/jogshuttleconfig.cpp)
endif()

### Find source files
add_subdirectory(abstractmodel)
add_subdirectory(assets)
add_subdirectory(audiomixer)
add_subdirectory(bin)
add_subdirectory(capture)
add_subdirectory(dialogs)
add_subdirectory(doc)
add_subdirectory(effects)
add_subdirectory(jobs)
add_subdirectory(lib)
add_subdirectory(library)
add_subdirectory(mltcontroller)
add_subdirectory(monitor)
add_subdirectory(onlineresources)
add_subdirectory(profiles)
add_subdirectory(project)
add_subdirectory(pythoninterfaces)
add_subdirectory(renderpresets)
add_subdirectory(scopes)
add_subdirectory(simplekeyframes)
add_subdirectory(timeline2)
add_subdirectory(titler)
add_subdirectory(transitions)
add_subdirectory(utils)
add_subdirectory(widgets)
add_subdirectory(xml)
## top_SRCS
file(GLOB top_SRCS "*.cpp")
if(NOT CRASH_AUTO_TEST)
    list(REMOVE_ITEM top_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/logger.cpp)
endif()
# string(REGEX REPLACE "${CMAKE_CURRENT_SOURCE_DIR}/lib/[^;]+;?" "" top_SRCS "${top_SRCS}")
list(REMOVE_ITEM top_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/main.cpp)
list(APPEND kdenlive_SRCS ${top_SRCS})
## Others special cases
kconfig_add_kcfg_files(kdenlive_SRCS kdenlivesettings.kcfgc)
install(FILES kdenlivesettings.kcfg DESTINATION ${KDE_INSTALL_KCFGDIR})
ecm_qt_declare_logging_category(kdenlive_SRCS HEADER kdenlive_debug.h IDENTIFIER KDENLIVE_LOG CATEGORY_NAME org.kde.multimedia.kdenlive)
if(NOT NODBUS)
    if(USE_VERSIONLESS_TARGETS)
        qt_add_dbus_adaptor(kdenlive_SRCS org.kdenlive.MainWindow.xml mainwindow.h MainWindow)
    else()
        qt5_add_dbus_adaptor(kdenlive_SRCS org.kdenlive.MainWindow.xml mainwindow.h MainWindow)
    endif()
else()
    add_subdirectory(render)
endif()
## UI's
file(GLOB kdenlive_UIS "ui/*.ui")
ki18n_wrap_ui(kdenlive_UIS ${kdenlive_UIS})
## MOC
if(USE_VERSIONLESS_TARGETS)
    qt_wrap_cpp(kdenlive_MOC definitions.h)
else()
    qt5_wrap_cpp(kdenlive_MOC definitions.h)
endif()
set_property(SOURCE definitions.h PROPERTY SKIP_AUTOMOC ON)

add_library(kdenliveLib STATIC ${kdenlive_SRCS} ${kdenlive_UIS} ${kdenlive_MOC} lib/localeHandling.cpp lib/localeHandling.h)

if(USE_VERSIONLESS_TARGETS)
    qt_add_resources(kdenlive_extra_SRCS icons.qrc uiresources.qrc)
else()
    qt5_add_resources(kdenlive_extra_SRCS icons.qrc uiresources.qrc)
endif()
## Icon for Windows and OSX
file(GLOB ICONS_SRCS "${CMAKE_CURRENT_SOURCE_DIR}/../data/icons/*-apps-kdenlive.png")
ecm_add_app_icon(kdenlive ICONS ${ICONS_SRCS}) # icon name = variable name
add_executable(kdenlive main.cpp ${kdenlive_extra_SRCS} ${kdenlive})
target_include_directories(kdenlive
    PRIVATE ${CMAKE_BINARY_DIR}
    )
target_include_directories(kdenlive
	SYSTEM PRIVATE ${MLT_INCLUDE_DIR} ${MLTPP_INCLUDE_DIR})
target_link_libraries(kdenlive kdenliveLib)
install(TARGETS kdenlive DESTINATION ${BIN_INSTALL_DIR})

install(FILES kdenliveui.rc DESTINATION ${KXMLGUI_INSTALL_DIR}/kdenlive)


target_include_directories(kdenliveLib
    PRIVATE ${CMAKE_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/lib/external
    ${CMAKE_CURRENT_SOURCE_DIR}/lib
    )
target_include_directories(kdenliveLib
	SYSTEM  PRIVATE ${MLT_INCLUDE_DIR} ${MLTPP_INCLUDE_DIR})
# Adds Qt definitions and include directories, and sets QT_LIBRARIES according
# to the components requested in find_package().
# KDE definitions and include directories *must* always come first, Qt follows
# (to avoid breaking builds when KDE and/or Qt are installed to different
# prefixes).
target_link_libraries(kdenliveLib
    KF5::WidgetsAddons
    KF5::Archive
    KF5::CoreAddons
    KF5::KIOCore
    KF5::KIOFileWidgets
    KF5::KIOWidgets
    KF5::NotifyConfig
    KF5::NewStuff
    KF5::XmlGui
    KF5::GuiAddons
    KF5::Notifications
    KF5::TextWidgets
    KF5::Declarative
    KF5::IconThemes
    KF5::Solid
    ${OPENGL_LIBRARIES}
    ${OPENGLES_LIBRARIES}
    ${MLT_LIBRARIES}
    ${MLTPP_LIBRARIES}
    ${CMAKE_DL_LIBS}
    ${CMAKE_THREAD_LIBS_INIT}
    kiss_fft)

if(USE_VERSIONLESS_TARGETS)
    target_link_libraries(kdenliveLib
        Qt::Svg
        Qt::Quick
        Qt::QuickControls2
        Qt::QuickWidgets
        Qt::Concurrent
        Qt::Multimedia
        Qt::NetworkAuth)
else()
    target_link_libraries(kdenliveLib
        Qt${QT_MAJOR_VERSION}::Svg
        Qt${QT_MAJOR_VERSION}::Quick
        Qt${QT_MAJOR_VERSION}::QuickControls2
        Qt${QT_MAJOR_VERSION}::QuickWidgets
        Qt${QT_MAJOR_VERSION}::Concurrent
        Qt${QT_MAJOR_VERSION}::Multimedia
        Qt${QT_MAJOR_VERSION}::NetworkAuth)
endif()
if (QT_MAJOR_VERSION STREQUAL "6")
    target_link_libraries(kdenliveLib Qt${QT_MAJOR_VERSION}::SvgWidgets)
endif()

if(NOT NODBUS)
  target_link_libraries(kdenliveLib KF5::DBusAddons)
endif()
if(BUILD_COVERAGE)
  target_link_libraries(kdenliveLib gcov)
endif()
set_property(TARGET kdenliveLib PROPERTY CXX_STANDARD 14)
add_definitions(${qt${QT_MAJOR_VERSION}gui_definitions} -DQT_STRICT_ITERATORS -DQT_NO_CAST_FROM_BYTEARRAY)

# Optional deps
if(CRASH_AUTO_TEST)
    target_compile_definitions(kdenliveLib PRIVATE CRASH_AUTO_TEST)
    if(TARGET RTTR::Core)
        target_link_libraries(kdenliveLib RTTR::Core)
    else()
        target_link_libraries(kdenliveLib RTTR::Core_Lib)
    endif()
endif()

if(DRMINGW_FOUND)
    target_compile_definitions(kdenlive PRIVATE -DUSE_DRMINGW)
    target_include_directories(kdenlive SYSTEM PRIVATE ${DRMINGW_INCLUDE_DIR})
    target_link_libraries(kdenlive ${DRMINGW_LIBRARY})
elseif(KF5Crash_FOUND)
    target_compile_definitions(kdenlive PRIVATE -DKF5_USE_CRASH)
    target_link_libraries(kdenlive KF5::Crash)
endif()

if(KF5_FILEMETADATA)
    target_compile_definitions(kdenliveLib PRIVATE -DKF5_USE_FILEMETADATA)
    target_link_libraries(kdenliveLib KF5::FileMetaData)
endif()

if(KF5_PURPOSE)
    target_compile_definitions(kdenliveLib PRIVATE -DKF5_USE_PURPOSE)
    target_link_libraries(kdenliveLib KF5::Purpose KF5::PurposeWidgets)
endif()

if(Q_WS_X11)
	target_include_directories(kdenliveLib SYSTEM PRIVATE ${X11_Xlib_INCLUDE_PATH})
    target_link_libraries(kdenliveLib ${X11_LIBRARIES})
endif()

if(SDL2_FOUND)
    target_link_libraries(kdenliveLib ${SDL2_LIBRARY})
elseif(SDL_FOUND)
    target_link_libraries(kdenliveLib ${SDL_LIBRARY})
endif()

if(LIBV4L2_FOUND)
    target_include_directories(kdenliveLib SYSTEM PRIVATE ${LIBV4L2_INCLUDE_DIR})
    target_link_libraries(kdenliveLib ${LIBV4L2_LIBRARY})
    target_compile_definitions(kdenliveLib PRIVATE -DUSE_V4L)
endif()

if(HAVE_LINUX_INPUT_H)
    target_compile_definitions(kdenliveLib PRIVATE -DUSE_JOGSHUTTLE)
    target_link_libraries(kdenliveLib media_ctrl)
endif()

if(NODBUS)
    target_compile_definitions(kdenliveLib PRIVATE -DNODBUS)
    target_compile_definitions(kdenlive PRIVATE -DNODBUS)
endif()

if (BUILD_QCH)
    ecm_add_qch(
        Kdenlive_QCH
        NAME kdenlive
        VERSION ${KDENLIVE_VERSION}
        ORG_DOMAIN org.kde
        SOURCE_DIRS
            .
        MD_MAINPAGE "${CMAKE_SOURCE_DIR}/README.md"
        TAGFILE_INSTALL_DESTINATION ${KDE_INSTALL_QTQCHDIR}
        QCH_INSTALL_DESTINATION ${KDE_INSTALL_QTQCHDIR}
        COMPONENT Devel
    )
endif()

=== tests/CMakeLists.txt ===
include_directories(${MLT_INCLUDE_DIR} ${MLTPP_INCLUDE_DIR} ..)
set(TEST_SOURCES ${CMAKE_CURRENT_SOURCE_DIR})
configure_file(tests_definitions.h.in tests_definitions.h)
kde_enable_exceptions()
add_executable(runTests
    TestMain.cpp
    abortutil.cpp
    colorscopestest.cpp
    compositiontest.cpp
    effectstest.cpp
    filetest.cpp
    mixtest.cpp
    groupstest.cpp
    keyframetest.cpp
    markertest.cpp
    modeltest.cpp
    regressions.cpp
    snaptest.cpp
    test_utils.cpp
    timewarptest.cpp
    titlertest.cpp
    treetest.cpp
    trimmingtest.cpp
    cachetest.cpp
    movetest.cpp
    subtitlestest.cpp
)
set_property(TARGET runTests PROPERTY CXX_STANDARD 14)
target_link_libraries(runTests kdenliveLib)
add_test(NAME runTests COMMAND ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/runTests -d yes)

=== thumbnailer/CMakeLists.txt ===
set(mltpreview_SRCS mltpreview.cpp ../src/lib/localeHandling.cpp)

include_directories(
  ${MLT_INCLUDE_DIR}
  ${MLTPP_INCLUDE_DIR}
)

add_library(mltpreview MODULE ${mltpreview_SRCS})


target_link_libraries(mltpreview
        Qt${QT_MAJOR_VERSION}::Core
        Qt${QT_MAJOR_VERSION}::Gui
        KF5::KIOCore
        KF5::KIOWidgets
  ${MLT_LIBRARIES}
  ${MLTPP_LIBRARIES}
)
#FIXME: For some reason the plugin only seems to work if installed in $lib/qt5/plugins and not in $lib/plugins like KF5 recommends
install(TARGETS mltpreview DESTINATION ${KDE_INSTALL_PLUGINDIR})
if (ECM_VERSION VERSION_GREATER_EQUAL "5.89.0")
    install(FILES mltpreview.desktop DESTINATION ${KDE_INSTALL_KSERVICESDIR})
else()
    install(FILES mltpreview.desktop DESTINATION ${KDE_INSTALL_KSERVICES5DIR})
endif()

=== data/scripts/CMakeLists.txt ===
INSTALL(FILES 
    checkpackages.py
    otiointerface.py
    speech.py
    speechtotext.py

DESTINATION ${DATA_INSTALL_DIR}${DATA_INSTALL_PREFIX}/scripts)

=== data/effects/frei0r/CMakeLists.txt ===
INSTALL (FILES 

frei0r_alpha0ps.xml
frei0r_alphagrad.xml
frei0r_alphaspot.xml
frei0r_B.xml
frei0r_balanc0r.xml
frei0r_baltan.xml
frei0r_bezier_curves.xml
frei0r_bgsubtract0r.xml
frei0r_bigsh0t_eq_mask.xml
frei0r_bigsh0t_eq_to_rect.xml
frei0r_bigsh0t_eq_to_stereo.xml
frei0r_bigsh0t_hemi_to_eq.xml
frei0r_bigsh0t_rect_to_eq.xml
frei0r_bigsh0t_stabilize_360.xml
frei0r_bigsh0t_transform_360.xml
frei0r_brightness.xml
frei0r_c0rners.xml
frei0r_cairogradient.xml
frei0r_cairoimagegrid.xml
frei0r_cartoon.xml
frei0r_cluster.xml
frei0r_colgate.xml
frei0r_coloradj_rgb.xml
frei0r_colordistance.xml
frei0r_colorize.xml
frei0r_colortap.xml
frei0r_contrast0r.xml
frei0r_curves.xml
frei0r_d90stairsteppingfix.xml
frei0r_defish0r.xml
frei0r_delay0r.xml
frei0r_delaygrab.xml
frei0r_distort0r.xml
frei0r_dither.xml
frei0r_edgeglow.xml
frei0r_emboss.xml
frei0r_equaliz0r.xml
frei0r_facebl0r.xml
frei0r_facedetect.xml
frei0r_flippo.xml
frei0r_G.xml
frei0r_glitch0r.xml
frei0r_glow.xml
frei0r_hqdn3d.xml
frei0r_hueshift0r.xml
frei0r_iirblur.xml
frei0r_keyspillm0pup.xml
frei0r_lenscorrection.xml
frei0r_letterb0xed.xml
frei0r_levels.xml
frei0r_lightgraffiti.xml
frei0r_luminance.xml
frei0r_mask0mate.xml
frei0r_medians.xml
frei0r_nervous.xml
frei0r_nosync0r.xml
frei0r_pixeliz0r.xml
frei0r_pr0be.xml
frei0r_pr0file.xml
frei0r_primaries.xml
frei0r_R.xml
frei0r_rgbnoise.xml
frei0r_rgbparade.xml
frei0r_rgbsplit0r.xml
frei0r_saturat0r.xml
frei0r_scale0tilt.xml
frei0r_scanline0r.xml
frei0r_select0r.xml
frei0r_sharpness.xml
frei0r_sigmoidaltransfer.xml
frei0r_sobel.xml
frei0r_softglow.xml
frei0r_sopsat.xml
frei0r_squareblur.xml
frei0r_tehroxx0r.xml
frei0r_three_point_balance.xml
frei0r_threelay0r.xml
frei0r_threshold0r.xml
frei0r_timeout.xml
frei0r_tint0r.xml
frei0r_transparency.xml
frei0r_twolay0r.xml
frei0r_vectorscope.xml
frei0r_vertigo.xml
frei0r_vignette.xml
DESTINATION ${DATA_INSTALL_DIR}${DATA_INSTALL_PREFIX}/effects)

=== data/effects/ladspa/CMakeLists.txt ===
INSTALL (FILES 

ladspa_declipper.xml
ladspa_equalizer.xml
ladspa_equalizer_15.xml
ladspa_librnnoise.xml
ladspa_limiter.xml
ladspa_phaser.xml
ladspa_pitch.xml
ladspa_pitch_scale.xml
ladspa_rate_scale.xml
ladspa_reverb.xml
ladspa_room_reverb.xml
ladspa_vinyl.xml

DESTINATION ${DATA_INSTALL_DIR}${DATA_INSTALL_PREFIX}/effects)

=== debian/changelog ===
kdenlive (22.08.3-1) unstable; urgency=medium

  * New upstream release.

 -- Patrick Matthäi <pmatthaei@debian.org>  Thu, 10 Nov 2022 09:31:28 +0100

kdenlive (22.08.2-1) unstable; urgency=medium

  * New upstream release.

 -- Patrick Matthäi <pmatthaei@debian.org>  Thu, 20 Oct 2022 15:35:45 +0200

=== debian/control ===
Source: kdenlive
Section: video
Priority: optional
Maintainer: Patrick Matthäi <pmatthaei@debian.org>
Homepage: https://kdenlive.org/
Standards-Version: 4.6.1
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13),
 pkg-config,
 cmake,
 appstream,
 pkg-kde-tools,
 libmlt-dev (>= 7.0.1),
 libmlt++-dev (>= 7.0.1),
 ffmpeg,
 libqt5opengl5-dev,
 libqt5networkauth5-dev,
 extra-cmake-modules (>= 5.59~),
 qtscript5-dev,
 qtmultimedia5-dev,
 qtquickcontrols2-5-dev,
 libqt5svg5-dev,
 libqt5webkit5-dev,
 libkf5kio-dev,
 libv4l-dev,
 libkf5archive-dev,
 libkf5bookmarks-dev,
 libkf5config-dev,
 libkf5configwidgets-dev,
 libkf5coreaddons-dev,
 libkf5dbusaddons-dev,
 libkf5doctools-dev,
 libkf5guiaddons-dev,
 libkf5iconthemes-dev,
 libkf5newstuff-dev,
 libkf5filemetadata-dev,
 libkf5purpose-dev,
 libkf5declarative-dev,
 libkf5crash-dev,
 libkf5notifications-dev,
 libkf5notifyconfig-dev,
 libkf5plotting-dev,
 libkf5textwidgets-dev,
 libkf5widgetsaddons-dev,
 qtdeclarative5-dev,
 qtwebengine5-dev [amd64 i386 arm64 armhf mipsel],
 libkf5xmlgui-dev

Package: kdenlive
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 kdenlive-data (= ${source:Version}),
 qml-module-qtquick2,
 qml-module-qtquick-controls,
 qml-module-qtgraphicaleffects,
 qml-module-qtqml-models2,
 qml-module-qtquick-controls2,
 qml-module-qtquick-dialogs,
 qml-module-qtquick-layouts,
 qml-module-qtquick-window2,
 breeze,
 breeze-icon-theme (>= 4:5.83.0),
 kinit,
 kded5,
 kio,
 melt,
 gstreamer1.0-plugins-bad,
 ffmpeg
Recommends: swh-plugins,
 oxygen-icon-theme,
 dvgrab,
 frei0r-plugins,
 recordmydesktop,
 dvdauthor,
 genisoimage
Suggests: khelpcenter,
 vlc | xine-ui
Breaks: kdenlive-data (<< 19.12.2-2~)
Replaces: kdenlive-data (<< 19.12.2-2~)
Description: non-linear video editor
 Kdenlive is a non-linear video editing suite, which supports DV, HDV and many
 more formats.
 Its main features are:
  * Guides and marker for organizing timelines
  * Copy and paste support for clips, effects and transitions
  * Real time changes
  * FireWire and Video4Linux capture
  * Screen grabbing
  * Exporting to any by FFMPEG supported format

Package: kdenlive-data
Architecture: all
Depends: ${misc:Depends}
Recommends: kdenlive
Breaks: ${kde-l10n:all}
Replaces: ${kde-l10n:all}
Description: non-linear video editor (data files)
 Kdenlive is a non-linear video editing suite, which supports DV, HDV and many
 more formats.
 Its main features are:
  * Guides and marker for organizing timelines
  * Copy and paste support for clips, effects and transitions
  * Real time changes
  * FireWire and Video4Linux capture
  * Screen grabbing
  * Exporting to any by FFMPEG supported format
 .
 This package contains the data files for kdenlive.

## kdenlive 22.12.0

=== debian/changelog ===
kdenlive (22.12.0-1) unstable; urgency=medium

  * New upstream release.
    - Add new build dependency qttools5-dev.

 -- Patrick Matthäi <pmatthaei@debian.org>  Thu, 15 Dec 2022 11:31:23 +0100

=== debian/control ===
--- 
+++ 
@@ -43,6 +43,7 @@
  libkf5textwidgets-dev,
  libkf5widgetsaddons-dev,
  qtdeclarative5-dev,
+ qttools5-dev,
  qtwebengine5-dev [amd64 i386 arm64 armhf mipsel],
  libkf5xmlgui-dev

## kdenlive 22.12.1

=== debian/changelog ===
kdenlive (22.12.1-1) unstable; urgency=medium

  * New upstream release.
  * Adjust lintian overrides.
  * Adjust debian/copyright.
  * Bump Standards-Version to 4.6.2.
  * Update upstream signing key.

 -- Patrick Matthäi <pmatthaei@debian.org>  Thu, 05 Jan 2023 17:23:18 +0100

## kdenlive 22.12.2

=== src/utils/CMakeLists.txt ===
set(kdenlive_SRCS
  ${kdenlive_SRCS}
  utils/clipboardproxy.cpp
  utils/colortools.cpp
  utils/devices.cpp
  utils/flowlayout.cpp
  utils/gentime.cpp
  utils/qcolorutils.cpp
  utils/thememanager.cpp
  utils/thumbnailcache.cpp
  utils/timecode.cpp
  PARENT_SCOPE
)

=== debian/changelog ===
kdenlive (22.12.2-1) unstable; urgency=medium

  * New upstream release.

 -- Patrick Matthäi <pmatthaei@debian.org>  Fri, 03 Feb 2023 09:49:23 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Patrick Matthäi <pmatthaei@debian.org>
 Homepage: https://kdenlive.org/
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Build-Depends: debhelper-compat (= 13),
  pkg-config,

## kdenlive 22.12.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 
 # KDE Application Version, managed by release script
 set (RELEASE_SERVICE_VERSION_MAJOR "22")
-set (RELEASE_SERVICE_VERSION_MINOR "08")
+set (RELEASE_SERVICE_VERSION_MINOR "12")
 set (RELEASE_SERVICE_VERSION_MICRO "3")
 
 set(KDENLIVE_VERSION "${RELEASE_SERVICE_VERSION_MAJOR}.${RELEASE_SERVICE_VERSION_MINOR}.${RELEASE_SERVICE_VERSION_MICRO}")
@@ -19,29 +19,36 @@
     cmake_policy(SET CMP0053 NEW)
 endif()
 
-# To be switched on when releasing.
-option(RELEASE_BUILD "Remove Git revision from program version" ON)
+include(FeatureSummary)
+include(GenerateExportHeader)
+
+# Register CMake options
+option(RELEASE_BUILD "Remove Git revision from program version" ON) # To be switched on when releasing.
 option(BUILD_TESTING "Build tests" ON)
 option(CRASH_AUTO_TEST "Auto-generate testcases upon some crashes (uses RTTR library, needed for fuzzing)" OFF)
 option(BUILD_FUZZING "Build fuzzing target" OFF)
 option(NODBUS "Build without DBus IPC" OFF)
 option(USE_VERSIONLESS_TARGETS "Use versionless targets" OFF)
+option(BUILD_QCH "Build source code documentation in QCH format (for e.g. Qt Assistant, Qt Creator & KDevelop)" OFF)
+add_feature_info(QCH ${BUILD_QCH} "Source code documentation in QCH format (for e.g. Qt Assistant, Qt Creator & KDevelop)")
+
+option(BUILD_DESIGNERPLUGIN "Build plugin for Qt Designer" OFF)
 
 # Minimum versions of main dependencies.
 set(MLT_MIN_MAJOR_VERSION 7)
-set(MLT_MIN_MINOR_VERSION 8)
+set(MLT_MIN_MINOR_VERSION 10)
 set(MLT_MIN_PATCH_VERSION 0)
 set(MLT_MIN_VERSION ${MLT_MIN_MAJOR_VERSION}.${MLT_MIN_MINOR_VERSION}.${MLT_MIN_PATCH_VERSION})
 
 # KDE Frameworks
-set(KF_DEP_VERSION "5.86.0")
+set(KF_DEP_VERSION "5.92.0")
 find_package(ECM ${KF_DEP_VERSION} REQUIRED CONFIG)
 set(KDE_COMPILERSETTINGS_LEVEL 5.80)
 set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH} ${CMAKE_SOURCE_DIR}/cmake/modules)
+
+## include ECM Modules
 include(KDECompilerSettings NO_POLICY_SCOPE)
-include(FeatureSummary)
 include(ECMInstallIcons)
-include(GenerateExportHeader)
 include(KDEInstallDirs)
 include(KDECMakeSettings)
 include(ECMOptionalAddSubdirectory)
@@ -50,17 +57,36 @@
 include(ECMQtDeclareLoggingCategory)
 include(ECMEnableSanitizers)
 include(ECMAddQch)
-if (ECM_VERSION VERSION_GREATER_EQUAL "5.89.0")
-    include(QtVersionOption)
-endif()
-if (ECM_VERSION VERSION_GREATER_EQUAL "5.91.0")
-    include(ECMDeprecationSettings)
-endif()
+include(QtVersionOption)
+include(ECMDeprecationSettings)
 
 add_definitions(-DTRANSLATION_DOMAIN=\"kdenlive\")
-find_package(KF5 ${KF_DEP_VERSION} REQUIRED COMPONENTS Archive Bookmarks CoreAddons Config ConfigWidgets
-                            KIO WidgetsAddons NotifyConfig NewStuff XmlGui Notifications GuiAddons TextWidgets IconThemes Declarative Solid
-                 OPTIONAL_COMPONENTS DocTools FileMetaData Crash Purpose)
+find_package(KF5 ${KF_DEP_VERSION}
+    REQUIRED COMPONENTS
+    Archive
+    Bookmarks
+    Codecs
+    CoreAddons
+    Config
+    ConfigWidgets
+    KIO
+    WidgetsAddons
+    NotifyConfig
+    NewStuff
+    XmlGui
+    Notifications
+    GuiAddons
+    TextWidgets
+    IconThemes
+    Declarative
+    Solid
+    FileMetaData
+
+    OPTIONAL_COMPONENTS
+    DocTools
+    Crash
+    Purpose
+)
 
 # Qt
 set(QT_MIN_VERSION 5.15.2)
@@ -68,15 +94,26 @@
     set(QT_MAJOR_VERSION 5)
 endif()
 
-if (ECM_VERSION VERSION_GREATER_EQUAL "5.91.0")
-    ecm_set_disabled_deprecation_versions(
-        QT ${QT_MIN_VERSION}
-        KF ${KF_DEP_VERSION}
-    )
-endif()
-
-
-find_package(Qt${QT_MAJOR_VERSION} REQUIRED COMPONENTS Core Widgets Svg Quick QuickControls2 Concurrent QuickWidgets Multimedia NetworkAuth)
+if (QT_MAJOR_VERSION STREQUAL "6")
+    set(USE_VERSIONLESS_TARGETS ON)
+endif()
+
+ecm_set_disabled_deprecation_versions(
+    QT ${QT_MIN_VERSION}
+    KF ${KF_DEP_VERSION}
+)
+
+find_package(Qt${QT_MAJOR_VERSION}
+    REQUIRED COMPONENTS
+    Core Widgets
+    Svg
+    Quick
+    QuickControls2
+    Concurrent
+    QuickWidgets
+    Multimedia
+    NetworkAuth
+)
 if (QT_MAJOR_VERSION STREQUAL "6")
     find_package(Qt${QT_MAJOR_VERSION} ${QT_MIN_VERSION} REQUIRED NO_MODULE COMPONENTS SvgWidgets)
 endif()
@@ -110,13 +147,6 @@
     set(DATA_INSTALL_PREFIX "")
 else()
     set(DATA_INSTALL_PREFIX "/kdenlive")
-endif()
-
-if(KF5FileMetaData_FOUND)
-  message(STATUS "Found KF5 FileMetadata to extract file metadata")
-  set(KF5_FILEMETADATA TRUE)
-else()
-  message(STATUS "KF5 FileMetadata not found, file metadata will not be available")
 endif()
 
 if(KF5Purpose_FOUND)
@@ -148,6 +178,9 @@
 endif()
 
 if(CRASH_AUTO_TEST)
+  if(BUILD_DESIGNERPLUGIN)
+    message(SEND_ERROR "The options CRASH_AUTO_TEST and BUILD_DESIGNERPLUGIN do not work together, disable one of both.")
+  endif()
   find_package(RTTR 0.9.6 QUIET)
   if(NOT RTTR_FOUND)
     message(STATUS "RTTR not found on system, will download source and build it")
@@ -157,11 +190,6 @@
     set(ECM_ENABLE_SANITIZERS fuzzer;address)
   endif()
 endif()
-
-feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)
-
-option(BUILD_QCH "Build source code documentation in QCH format (for e.g. Qt Assistant, Qt Creator & KDevelop)" OFF)
-add_feature_info(QCH ${BUILD_QCH} "Source code documentation in QCH format (for e.g. Qt Assistant, Qt Creator & KDevelop)")
 
 set(FFMPEG_SUFFIX "" CACHE STRING "FFmpeg custom suffix")
 configure_file(config-kdenlive.h.cmake config-kdenlive.h @ONLY)
@@ -172,6 +200,8 @@
 add_subdirectory(renderer)
 add_subdirectory(thumbnailer)
 add_subdirectory(data)
+
+# Install
 ki18n_install(po)
 
 if (BUILD_QCH)
@@ -187,7 +217,11 @@
 install(FILES AUTHORS README.md DESTINATION ${CMAKE_INSTALL_DOCDIR})
 install(DIRECTORY LICENSES DESTINATION ${CMAKE_INSTALL_DOCDIR})
 
-install(FILES kdenlive.categories DESTINATION ${KDE_INSTALL_LOGGINGCATEGORIESDIR})
+ecm_qt_install_logging_categories(
+    EXPORT KDENLIVE
+    FILE kdenlive.categories
+    DESTINATION ${KDE_INSTALL_LOGGINGCATEGORIESDIR}
+)
 
 # Tests
 if(BUILD_TESTING)
@@ -199,6 +233,8 @@
     message(STATUS "Fuzzing build was requested but not enabled because compiler is ${CMAKE_CXX_COMPILER_ID} and not Clang")
 endif()
 
+feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES FATAL_ON_MISSING_REQUIRED_PACKAGES)
+
 # pre-commit hook
 include(KDEGitCommitHooks)
 kde_configure_git_pre_commit_hook(CHECKS CLANG_FORMAT)

=== data/CMakeLists.txt ===
--- 
+++ 
@@ -37,11 +37,7 @@
 
   DESTINATION ${KDE_INSTALL_DATADIR}${DATA_INSTALL_PREFIX})
 
-if (ECM_VERSION VERSION_GREATER_EQUAL "5.89.0")
-    install(FILES  kdenlive.notifyrc DESTINATION ${KDE_INSTALL_KNOTIFYRCDIR})
-else()
-    install(FILES  kdenlive.notifyrc DESTINATION ${KDE_INSTALL_KNOTIFY5RCDIR})
-endif()
+install(FILES  kdenlive.notifyrc DESTINATION ${KDE_INSTALL_KNOTIFYRCDIR})
 install(FILES profiles.xml DESTINATION ${KDE_INSTALL_DATADIR}${DATA_INSTALL_PREFIX}/export)
 install(FILES org.kde.kdenlive.appdata.xml DESTINATION ${KDE_INSTALL_METAINFODIR})
 install(FILES org.kde.kdenlive.desktop DESTINATION ${KDE_INSTALL_APPDIR})

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -61,25 +61,41 @@
 add_subdirectory(pythoninterfaces)
 add_subdirectory(renderpresets)
 add_subdirectory(scopes)
-add_subdirectory(simplekeyframes)
 add_subdirectory(timeline2)
 add_subdirectory(titler)
 add_subdirectory(transitions)
 add_subdirectory(utils)
 add_subdirectory(widgets)
 add_subdirectory(xml)
-## top_SRCS
-file(GLOB top_SRCS "*.cpp")
-if(NOT CRASH_AUTO_TEST)
-    list(REMOVE_ITEM top_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/logger.cpp)
-endif()
-# string(REGEX REPLACE "${CMAKE_CURRENT_SOURCE_DIR}/lib/[^;]+;?" "" top_SRCS "${top_SRCS}")
-list(REMOVE_ITEM top_SRCS ${CMAKE_CURRENT_SOURCE_DIR}/main.cpp)
-list(APPEND kdenlive_SRCS ${top_SRCS})
+
+## toplevel source code files
+list(APPEND kdenlive_SRCS
+    core.cpp
+    definitions.cpp
+    docktitlebarmanager.cpp
+    layoutmanagement.cpp
+    mainwindow.cpp
+    mltconnection.cpp
+    statusbarmessagelabel.cpp
+    undohelper.cpp
+    glaxnimatelauncher.cpp
+)
+
+if(CRASH_AUTO_TEST)
+    list(APPEND kdenlive_SRCS logger.cpp)
+endif()
+
 ## Others special cases
 kconfig_add_kcfg_files(kdenlive_SRCS kdenlivesettings.kcfgc)
 install(FILES kdenlivesettings.kcfg DESTINATION ${KDE_INSTALL_KCFGDIR})
-ecm_qt_declare_logging_category(kdenlive_SRCS HEADER kdenlive_debug.h IDENTIFIER KDENLIVE_LOG CATEGORY_NAME org.kde.multimedia.kdenlive)
+ecm_qt_declare_logging_category(kdenlive_SRCS
+    HEADER kdenlive_debug.h
+    IDENTIFIER KDENLIVE_LOG
+    CATEGORY_NAME org.kde.multimedia.kdenlive
+    DESCRIPTION "kdenlive"
+    EXPORT KDENLIVE
+)
+
 if(NOT NODBUS)
     if(USE_VERSIONLESS_TARGETS)
         qt_add_dbus_adaptor(kdenlive_SRCS org.kdenlive.MainWindow.xml mainwindow.h MainWindow)
@@ -89,9 +105,11 @@
 else()
     add_subdirectory(render)
 endif()
+
 ## UI's
 file(GLOB kdenlive_UIS "ui/*.ui")
 ki18n_wrap_ui(kdenlive_UIS ${kdenlive_UIS})
+
 ## MOC
 if(USE_VERSIONLESS_TARGETS)
     qt_wrap_cpp(kdenlive_MOC definitions.h)
@@ -107,9 +125,12 @@
 else()
     qt5_add_resources(kdenlive_extra_SRCS icons.qrc uiresources.qrc)
 endif()
+
 ## Icon for Windows and OSX
 file(GLOB ICONS_SRCS "${CMAKE_CURRENT_SOURCE_DIR}/../data/icons/*-apps-kdenlive.png")
 ecm_add_app_icon(kdenlive ICONS ${ICONS_SRCS}) # icon name = variable name
+
+## Kdenlive Executable
 add_executable(kdenlive main.cpp ${kdenlive_extra_SRCS} ${kdenlive})
 target_include_directories(kdenlive
     PRIVATE ${CMAKE_BINARY_DIR}
@@ -117,11 +138,11 @@
 target_include_directories(kdenlive
 	SYSTEM PRIVATE ${MLT_INCLUDE_DIR} ${MLTPP_INCLUDE_DIR})
 target_link_libraries(kdenlive kdenliveLib)
-install(TARGETS kdenlive DESTINATION ${BIN_INSTALL_DIR})
-
-install(FILES kdenliveui.rc DESTINATION ${KXMLGUI_INSTALL_DIR}/kdenlive)
-
-
+install(TARGETS kdenlive DESTINATION ${KDE_INSTALL_BINDIR})
+
+install(FILES kdenliveui.rc DESTINATION ${KDE_INSTALL_KXMLGUIDIR}/kdenlive)
+
+## Kdenlive Lib
 target_include_directories(kdenliveLib
     PRIVATE ${CMAKE_BINARY_DIR}
     ${CMAKE_CURRENT_SOURCE_DIR}
@@ -143,7 +164,6 @@
     KF5::KIOFileWidgets
     KF5::KIOWidgets
     KF5::NotifyConfig
-    KF5::NewStuff
     KF5::XmlGui
     KF5::GuiAddons
     KF5::Notifications
@@ -151,6 +171,7 @@
     KF5::Declarative
     KF5::IconThemes
     KF5::Solid
+    KF5::FileMetaData
     ${OPENGL_LIBRARIES}
     ${OPENGLES_LIBRARIES}
     ${MLT_LIBRARIES}
@@ -159,6 +180,14 @@
     ${CMAKE_THREAD_LIBS_INIT}
     kiss_fft)
 
+if(KF5NewStuff_VERSION VERSION_LESS "5.90")
+    target_link_libraries(kdenliveLib
+        KF5::NewStuff)
+else()
+    target_link_libraries(kdenliveLib
+        KF5::NewStuffWidgets)
+endif()
+
 if(USE_VERSIONLESS_TARGETS)
     target_link_libraries(kdenliveLib
         Qt::Svg
@@ -208,11 +237,6 @@
 elseif(KF5Crash_FOUND)
     target_compile_definitions(kdenlive PRIVATE -DKF5_USE_CRASH)
     target_link_libraries(kdenlive KF5::Crash)
-endif()
-
-if(KF5_FILEMETADATA)
-    target_compile_definitions(kdenliveLib PRIVATE -DKF5_USE_FILEMETADATA)
-    target_link_libraries(kdenliveLib KF5::FileMetaData)
 endif()
 
 if(KF5_PURPOSE)

=== tests/CMakeLists.txt ===
include_directories(${MLT_INCLUDE_DIR} ${MLTPP_INCLUDE_DIR} ..)
set(TEST_SOURCES ${CMAKE_CURRENT_SOURCE_DIR})
configure_file(tests_definitions.h.in tests_definitions.h)
kde_enable_exceptions()

set(KdenliveTest_SOURCES
    colorscopestest.cpp
    compositiontest.cpp
    effectstest.cpp
    filetest.cpp
    mixtest.cpp
    groupstest.cpp
    keyframetest.cpp
    markertest.cpp
    modeltest.cpp
    regressions.cpp
    snaptest.cpp
    timewarptest.cpp
    titlertest.cpp
    treetest.cpp
    trimmingtest.cpp
    cachetest.cpp
    movetest.cpp
    subtitlestest.cpp
    spacertest.cpp
)

include(ECMAddTests)

foreach(_source ${KdenliveTest_SOURCES})
  get_filename_component(_targetname ${_source} NAME_WE)
  ecm_add_test(
      TestMain.cpp
      test_utils.cpp
      abortutil.cpp
      ${_source}
      TEST_NAME ${_targetname}
      LINK_LIBRARIES kdenliveLib
  )
  set_property(TARGET ${_targetname} PROPERTY CXX_STANDARD 14)
endforeach()

=== data/icons/CMakeLists.txt ===
ecm_install_icons(ICONS
  16-actions-keyframe.svg
  16-actions-keyframe-add.svg
  16-actions-keyframe-disable.svg
  16-actions-keyframe-duplicate.svg
  16-actions-keyframe-next.svg
  16-actions-keyframe-previous.svg
  16-actions-keyframe-record.svg
  16-actions-keyframe-remove.svg
  16-actions-add-subtitle.svg
  22-actions-keyframe.svg
  22-actions-keyframe-add.svg
  22-actions-keyframe-disable.svg
  22-actions-keyframe-duplicate.svg
  22-actions-keyframe-next.svg
  22-actions-keyframe-previous.svg
  22-actions-keyframe-record.svg
  22-actions-keyframe-remove.svg
  sc-actions-add-subtitle.svg
  16-apps-kdenlive.png
  22-apps-kdenlive.png
  32-apps-kdenlive.png
  48-apps-kdenlive.png
  64-apps-kdenlive.png
  128-apps-kdenlive.png
  256-apps-kdenlive.png
  sc-apps-kdenlive.svgz
  32-mimetypes-application-x-kdenlivetitle.png
  64-mimetypes-application-x-kdenlivetitle.png
  128-mimetypes-application-x-kdenlivetitle.png
  sc-mimetypes-application-x-kdenlivetitle.svgz
  sc-mimetypes-application-x-kdenlive.svgz
  sc-mimetypes-video-mlt-playlist.svgz
  DESTINATION ${KDE_INSTALL_ICONDIR})

=== data/lumas/CMakeLists.txt ===
INSTALL(FILES 
PAL/bi-linear_x.pgm
PAL/bi-linear_y.pgm
PAL/burst.pgm
PAL/checkerboard_small.pgm
PAL/clock.pgm
PAL/cloud.pgm
PAL/curtain.pgm
PAL/horizontal_blinds.pgm
PAL/linear_x.pgm
PAL/linear_y.pgm
PAL/radial-bars.pgm
PAL/radial.pgm
PAL/spiral.pgm
PAL/spiral2.pgm
PAL/square.pgm
PAL/square2-bars.pgm
PAL/square2.pgm
PAL/symmetric_clock.pgm
DESTINATION ${KDE_INSTALL_DATADIR}${DATA_INSTALL_PREFIX}/lumas/PAL)

INSTALL(FILES 
HD/bi-linear_x.pgm
HD/bi-linear_y.pgm
HD/burst.pgm
HD/checkerboard_small.pgm
HD/clock.pgm
HD/cloud.pgm
HD/curtain.pgm
HD/horizontal_blinds.pgm
HD/linear_x.pgm
HD/linear_y.pgm
HD/radial-bars.pgm
HD/radial.pgm
HD/spiral.pgm
HD/spiral2.pgm
HD/square.pgm
HD/square2-bars.pgm
HD/square2.pgm
HD/symmetric_clock.pgm
DESTINATION ${KDE_INSTALL_DATADIR}${DATA_INSTALL_PREFIX}/lumas/HD)

=== data/scripts/CMakeLists.txt ===
INSTALL(FILES 
    checkpackages.py
    otiointerface.py
    speech.py
    speechtotext.py

DESTINATION ${KDE_INSTALL_DATADIR}${DATA_INSTALL_PREFIX}/scripts)

=== data/titles/CMakeLists.txt ===
FILE(GLOB files "${CMAKE_CURRENT_SOURCE_DIR}/*.kdenlivetitle")
INSTALL (FILES ${files} DESTINATION ${KDE_INSTALL_DATADIR}${DATA_INSTALL_PREFIX}/titles)

=== plugins/sampleplugin/CMakeLists.txt ===
set(sampleplugin_SRCS sampleplugin.cpp)

ki18n_wrap_ui(sampleplugin_UIS countdown_ui.ui)

add_library(kdenlive_sampleplugin MODULE WITH_PREFIX
  ${sampleplugin_SRCS}
  ${sampleplugin_UIS}
)

add_definitions(${KDE4_DEFINITIONS})


include(${QT_USE_FILE})

#add_definitions(${QT_DEFINITIONS})
#add_definitions(-DQT_NO_DEBUG)
add_definitions(-DQT_PLUGIN)
add_definitions(-DQT_SHARED)

target_link_libraries(kdenlive_sampleplugin
  KF5::KDELibs4Support
  
  KF5::KIOCore
  ${QT_LIBRARIES}
)

install(TARGETS kdenlive_sampleplugin DESTINATION ${KDE_INSTALL_PLUGINDIR})

=== src/bin/CMakeLists.txt ===
set(kdenlive_SRCS
  ${kdenlive_SRCS}
  bin/abstractprojectitem.cpp
  bin/bin.cpp
  bin/bincommands.cpp
  bin/binplaylist.cpp
  bin/clipcreator.cpp
  bin/filewatcher.cpp
  bin/generators/generators.cpp
  bin/model/markerlistmodel.cpp
  bin/model/markersortmodel.cpp
  bin/model/subtitlemodel.cpp
  bin/projectclip.cpp
  bin/projectfolder.cpp
  bin/projectitemmodel.cpp
  bin/projectsortproxymodel.cpp
  bin/projectsubclip.cpp
  bin/tagwidget.cpp
  PARENT_SCOPE
)

=== src/dialogs/CMakeLists.txt ===
set(kdenlive_SRCS
  ${kdenlive_SRCS}
  dialogs/clipcreationdialog.cpp
  dialogs/encodingprofilesdialog.cpp
  dialogs/kdenlivesettingsdialog.cpp
  dialogs/markerdialog.cpp
  dialogs/exportguidesdialog.cpp
  dialogs/profilesdialog.cpp
  dialogs/proxytest.cpp
  dialogs/renderwidget.cpp
  dialogs/renderpresetdialog.cpp
  dialogs/speechdialog.cpp
  dialogs/subtitleedit.cpp
  dialogs/textbasededit.cpp
  dialogs/timeremap.cpp
  dialogs/titletemplatedialog.cpp
  dialogs/wizard.cpp
  dialogs/splash.cpp
  PARENT_SCOPE)

=== src/lib/CMakeLists.txt ===
add_subdirectory(audio)
add_subdirectory(external)
set(kdenlive_SRCS
  ${kdenlive_SRCS}
  lib/qtimerWithTime.cpp
  PARENT_SCOPE)

=== debian/changelog ===
kdenlive (22.12.3-2+deb12u1) testing-proposed-updates; urgency=medium

  * Bump version and upload to t-p-u.

 -- Patrick Matthäi <pmatthaei@debian.org>  Mon, 17 Apr 2023 11:49:39 +0200

kdenlive (22.12.3-2) unstable; urgency=medium

  * Add missing dependency on qml-module-org-kde-newstuff.
    Closes: #1032470

 -- Patrick Matthäi <pmatthaei@debian.org>  Fri, 10 Mar 2023 09:43:45 +0100

kdenlive (22.12.3-1) unstable; urgency=medium

  * New upstream release.
  * Add dependency on qml-module-org-kde-kcm.
    Closes: #1030782
  * Update signing-key.asc.

 -- Patrick Matthäi <pmatthaei@debian.org>  Tue, 07 Mar 2023 09:13:27 +0100

=== debian/control ===
--- 
+++ 
@@ -60,6 +60,8 @@
  qml-module-qtquick-dialogs,
  qml-module-qtquick-layouts,
  qml-module-qtquick-window2,
+ qml-module-org-kde-kcm,
+ qml-module-org-kde-newstuff,
  breeze,
  breeze-icon-theme (>= 4:5.83.0),
  kinit,

=== debian/rules ===
#!/usr/bin/make -f

l10npkgs_firstversion_ok := 4:16.04.3-4~
include /usr/share/pkg-kde-tools/qt-kde-team/2/l10n-packages.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

EXTRAFLAGS :=
ifeq ($(DEB_BUILD_ARCH_OS),kfreebsd)
	EXTRAFLAGS := -DNO_JOGSHUTTLE=YES
endif

%:
	dh $@ --with kf5

override_dh_auto_configure:
	dh_auto_configure -Skf5 -- $(EXTRAFLAGS)

override_dh_install:
	dh_install
	rm -rf $(CURDIR)/debian/kdenlive-data/usr/share/doc/Kdenlive/
	rm -rf $(CURDIR)/debian/kdenlive-data/usr/share/icons/breeze-dark

override_dh_auto_test:

override_dh_gencontrol: l10npkgs_firstversion_ok
	dh_gencontrol

## kdenlive 23.04.0-1~ubuntu22.04.1+11.0trisquel2

=== debian/changelog ===
kdenlive (4:23.04.0-1~ubuntu22.04.1+11.0trisquel2) aramo-backports; urgency=medium

  * Backported from official PPA for kdenlive

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Sun, 30 Apr 2023 00:39:45 +0000

kdenlive (4:23.04.0-1~ubuntu22.04.1) jammy; urgency=low

  * Auto build.

 -- Julius Künzel <jk.kdedev@smartlab.uber.space>  Sat, 29 Apr 2023 19:18:38 +0000

=== debian/control ===
Source: kdenlive
Section: video
Priority: optional
Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
XSBC-Original-Maintainer: Debian/Kubuntu Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Homepage: https://kdenlive.org/
Standards-Version: 4.6.2
Rules-Requires-Root: no
Build-Depends: cmake (>= 3.16~),
               debhelper (>= 10),
               extra-cmake-modules (>= 5.92~),
               ffmpeg,
               libkf5archive-dev,
               libkf5bookmarks-dev,
               libkf5config-dev,
               libkf5configwidgets-dev,
               libkf5coreaddons-dev,
               libkf5crash-dev,
               libkf5dbusaddons-dev,
               libkf5declarative-dev,
               libkf5doctools-dev,
               libkf5filemetadata-dev,
               libkf5guiaddons-dev,
               libkf5iconthemes-dev,
               libkf5kio-dev,
               libkf5newstuff-dev,
               libkf5notifications-dev,
               libkf5notifyconfig-dev,
               libkf5plotting-dev,
               libkf5purpose-dev,
               libkf5textwidgets-dev,
               libkf5widgetsaddons-dev,
               libkf5xmlgui-dev,
               libmlt++7-dev (>= 7.8.0),
               libmlt7-dev (>= 7.8.0),
               libqt5networkauth5-dev,
               libqt5opengl5-dev,
               libqt5svg5-dev,
               libqt5webkit5-dev,
               libv4l-dev,
               pkg-config,
               pkg-kde-tools,
               qtbase5-dev,
               qttools5-dev,
               qtdeclarative5-dev,
               qtmultimedia5-dev,
               qtquickcontrols2-5-dev,
Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kdenlive
Vcs-Git: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/kdenlive

Package: kdenlive
Architecture: any
Depends: breeze,
         breeze-icon-theme,
         ffmpeg,
         kded5,
         kdenlive-data (= ${source:Version}),
         kinit,
         kio,
         melt-7,
         qml-module-qtgraphicaleffects,
         qml-module-qtqml-models2,
         qml-module-qtquick-controls,
         qml-module-qtquick-controls2,
         qml-module-qtquick-dialogs,
         qml-module-qtquick-layouts,
         qml-module-qtquick-window2,
         qml-module-qtquick2,
         qml-module-org-kde-kcm,
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: frei0r-plugins,
            swh-plugins,
Suggests: vlc
Description: non-linear video editor
 Kdenlive is a non-linear video editing suite, which supports DV, HDV and many
 more formats.
 Its main features are:
  * Guides and marker for organizing timelines
  * Copy and paste support for clips, effects and transitions
  * Real time changes
  * FireWire and Video4Linux capture
  * Screen grabbing
  * Exporting to any by FFMPEG supported format

Package: kdenlive-data
Architecture: all
Depends: ${misc:Depends}
Recommends: kdenlive
Breaks: ${kde-l10n:all}
Replaces: ${kde-l10n:all}
Description: non-linear video editor (data files)
 Kdenlive is a non-linear video editing suite, which supports DV, HDV and many
 more formats.
 Its main features are:
  * Guides and marker for organizing timelines
  * Copy and paste support for clips, effects and transitions
  * Real time changes
  * FireWire and Video4Linux capture
  * Screen grabbing
  * Exporting to any by FFMPEG supported format
 .
 This package contains the data files for kdenlive.
